//typedef char bool;
#define fTrue 1
#define fFalse 0





typedef struct char_prop
{
    char fBold;
    char fUnderline;
    char fItalic;
    char caps;
    char underline;
    char supersub;
    int  font;
    int  fontsize;
				int  unicoden;

    int  actionbits[2];

} CHP;                  // CHaracter Properties

typedef enum {justL, justR, justC, justF } JUST;
typedef struct para_prop
{
    int xaLeft;                 // left indent in twips
    int xaRight;                // right indent in twips
    int xaFirst;                // first line indent in twips
    JUST just;                  // justification
    char hpzone;
    char hpconsec;
    char hpcaps;
    char hpauto;
    char pagebreak;

    int  actionbits[2];

} PAP;                  // PAragraph Properties




typedef struct tabstr
{
	int type;
	int posn;
	int leader;

} tabstr;


#define MAXTABS 128

typedef struct tab_prop
{
	int    ntabs;
	tabstr tab[MAXTABS];


} TAB;                  // Tab ruler





typedef enum {sbkNon, sbkCol, sbkEvn, sbkOdd, sbkPg} SBK;
typedef enum {pgDec, pgURom, pgLRom, pgULtr, pgLLtr} PGN;
typedef struct sect_prop
{
    int cCols;                  // number of columns
    SBK sbk;                    // section break type
    int xaPgn;                  // x position of page number in twips
    int yaPgn;                  // y position of page number in twips
    PGN pgnFormat;              // how the page number is formatted

    int  actionbits[1];

} SEP;                  // SEction Properties

typedef struct doc_prop
{
    int xaPage;                 // page width in twips
    int yaPage;                 // page height in twips
    int xaLeft;                 // left margin in twips
    int yaTop;                  // top margin in twips
    int xaRight;                // right margin in twips
    int yaBottom;               // bottom margin in twips
    int pgnStart;               // starting page number in twips
    char fFacingp;              // facing pages enabled?
    char fLandscape;            // landscape or portrait?

    int  actionbits[2];

} DOP;                  // DOcument Properties


#define MAXSTYLE 64

typedef struct style_stack
{
 int style[MAXSTYLE];
 int snum;


} SSTACK;




typedef enum { rdsNorm, rdsSkip, rdsFont, rdsColour, rdsStyle, rdsPict, rdsKeyCode, rdsTabs } RDS;              // Rtf Destination State
typedef enum { risNorm, risBin, risHex } RIS;       // Rtf Internal State




typedef struct save             // property save structure
{
    struct save *pNext;         // next save
    CHP chp;
    PAP pap;
    SEP sep;
    DOP dop;
    RDS rds;
    RIS ris;
 SSTACK sstack;
} SAVE;

// What types of properties are there?

typedef enum {ipropBold, ipropItalic, ipropUnderline, ipropLeftInd,
              ipropRightInd, ipropFirstInd, ipropCols, ipropPgnX,
              ipropPgnY, ipropXaPage, ipropYaPage, ipropXaLeft,
              ipropXaRight, ipropYaTop, ipropYaBottom, ipropPgnStart,
              ipropSbk, ipropPgnFormat, ipropFacingp, ipropLandscape,
              ipropJust, ipropPard, ipropPlain, ipropSectd,
              ipropFont,
              ipropCaps,
              ipropPageBreak,
              ipropSuperSub,
              ipropHpZone,
              ipropHpConsec,
              ipropHpCaps,
              ipropHpAuto,
              ipropFontSize,
														ipropunicoden,
              ipropCStyle,
              ipropPStyle,
              ipropSStyle,
              ipropBasedon,
              ipropAdditive,
              ipropMax } IPROP;

typedef enum {actnSpec, actnByte, actnWord} ACTN;
typedef enum {propChp, propPap, propSep, propDop, propFont} PROPTYPE;

typedef enum {ipropFontFamily} FONTTYPE;

typedef enum {ipropTabs} TABTYPE;
              
typedef enum {fnil,froman,fswiss,fmodern,fscript,fdecor,ftech,fbidi} FONTSTYLE;

typedef enum {ipropColourRed,ipropColourGreen,ipropColourBlue,} COLOURTYPE;

typedef enum {ipropRTF,ipropANSI,ipropMac,ipropPC,ipropPCA,ipropDefFont} SYSTEMTYPE;


typedef enum {ipropPictemf,ipropPictpng,ipropPictjpeg,ipropPictwmf,ipropPictpixwidth,
              ipropPictpixheight,ipropPicttwipwidth,ipropPicttwipheight,ipropPictxscale,
              ipropPictyscale,ipropPictfit,ipropPictcroptop,ipropPictcropbot,
              ipropPictcropleft,ipropPictcropright,ipropPictmetabitmap,
              ipropPictmetabitmapbpp} PICTTYPE;





typedef struct propmod
{
    ACTN actn;              // size of value
    PROPTYPE prop;          // structure containing value
    int  offset;            // offset of value from base of structure
} PROP;

typedef enum {ipfnBin, ipfnHex, ipfnSkipDest } IPFN;
typedef enum {idestSkip, idestFont, idestColour, idestStyleSheet,idestPict,idestKeyCode,idestTabs  } IDEST;
typedef enum {kwdChar, kwdDest, kwdProp, kwdSpec, kwdFont, kwdColour, kwdSystem, kwdTabs, kwdStyle, kwdPict} KWD;

typedef struct symbol
{
    char *szKeyword;        // RTF keyword
    int  dflt;              // default value to use
    bool fPassDflt;         // true to use default value from this table
    KWD  kwd;               // base action to take
    int  idx;               // index into property table if kwd == kwdProp
                            // index into destination table if kwd == kwdDest
                            // character to print if kwd == kwdChar
} SYM;
 